export class Ring {
  constructor(container, item, slot) {
    this.item = item;
    const power = ringsPowers[this.item.id][this.category][parseInt(this.level)];

    if (this.item.getLore()[0] == undefined) {
      this.item.setLore([ `§r§eRing level: ${this.level}§r`, `§r§3${power}§r\n`, `§r§5Use Shift + Item use for upgrade item§r` ]);
    }
    container.setItem(slot, this.item);
  }

  get level() {
    const dataLore = this.item.getLore()[0];
      
    if (dataLore == undefined) {
      return "0-A";
    }
    return dataLore.match(/([0-3]-[A-z])/g)[0];
  }

  get category() {
    return this.level.match(/([A-z])/g);
  }

  upgrade() {
    let category = this.category;
    let level = parseInt(this.level);

    if (category == "C" && level == 1) {
      return null;
    } else if (level === 3) {
      category = category == "A" ? "B" : category == "B" ? "C" : "";
      level = 0;
    } else {
      level++;
    }
    const power = ringsPowers[this.item.id][category][level];
    this.item.setLore([ `§r§eRing level: ${level}-${category}§r`, `§r§3${power}§r\n`, `§r§5Use Shift + Item use for upgrade item§r` ]);
    
    return this.item;
  }
}

const ringsPowers = {
  "divine:vitality_ring": {
    "A": [
      "Health >= 14 regeneration 1",
      "Health >= 10 regeneration 1",
      "Health >= 6 regeneration 1",
      "Regeneration 1 Infinite"
    ],
    "B": [
      "Regeneration 1 Infinite",
      "Regeneration 1 Infinite",
      "Regeneration 2 Infinite",
      "Regeneration 3 Infinite"
    ],
    "C": [
      "No special power",
      "Health minor or equal 2 regeneration 5"
    ]
  },
  "divine:versatility_ring": {
    "A": [
      "Full health speed 1",
      "Health >= 18 speed 1",
      "Health >= 14 speed 1",
      "Speed 1 Infinite"
    ],
    "B": [
      "Speed 1 Infinite",
      "Speed 1 Infinite",
      "Speed 2 Infinite",
      "Speed 3 Infinite"
    ],
    "C": [
      "No special power",
      "Haste 1 Infinite"
    ]
  },
  "divine:revenge_ring": {
    "A": [
      "Health =< 4 strength 1",
      "Health =< 6 strength 1",
      "Health =< 8 strength 1",
      "Strength 1 Infinite",
    ],
    "B": [
      "Strength 1 Infinite",
      "Strength 1 Infinite",
      "Strength 2 Infinite",
      "Strength 3 Infinite"
    ],
    "C": [
      "No special power",
      "Health =< 2 strength 10"
    ]
  }
}
